package com.ims.eval.controller;


import com.alibaba.fastjson.JSONObject;
import com.ims.eval.entity.EvaluationDeptBusinessAssessment;
import com.ims.eval.entity.EvaluationDeptBusinessPlan;
import com.ims.eval.entity.EvaluationDeptProcess;
import com.ims.eval.entity.dto.result.R;
import com.ims.eval.service.IEvaluationDeptBusinessAssessmentService;
import com.ims.eval.service.IEvaluationDeptBusinessPlanService;
import com.ims.eval.service.IEvaluationDeptProcessService;
import com.ims.eval.service.IUserService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2025-02-08
 */
@RestController
@RequestMapping("/evaluation-dept-process")
public class EvaluationDeptProcessController {
	@Resource
	private IUserService userService;

	@Resource
	private HttpServletRequest request;

	@Resource
	private IEvaluationDeptProcessService evaluationDeptProcessService;

	@Resource
	private IEvaluationDeptBusinessAssessmentService evaluationDeptBusinessAssessmentService;

	@Resource
	private IEvaluationDeptBusinessPlanService evaluationDeptBusinessPlanService;

	/**
	 * 添加审批人员
	 *
	 * @param id         主键
	 * @param employeeNo 用户编号
	 * @return 结果
	 */
	@PostMapping(value = "/addProcessPersonal")
	public R addApprovalLeader(@RequestParam(value = "id") String id,
							   @RequestParam(value = "employeeNo") String employeeNo,
							   @RequestParam(value = "businessType") String businessType) {
		boolean b = false;
		JSONObject jsonArr = userService.getLoginNameByUserInfo(employeeNo, request);
		JSONObject data = (JSONObject) jsonArr.get("data");
		if (data.toJSONString().length() > 0) {
			EvaluationDeptProcess edp = evaluationDeptProcessService.getById(id);
//			if (null != edp && businessType.equals(edp.getBusinessType())) {
			if (null != edp) {
				edp.setDeptPersonalName(String.valueOf(data.get("name")));
				b = evaluationDeptProcessService.updateById(edp);
				if (b) {
					return R.ok().data(b);
				} else {
					return R.error("添加人员失败！");
				}
			} else if (null != edp) {
				return R.error("添加人员失败，请联系管理员！");
			}
			EvaluationDeptProcess evaluationDeptProcess = new EvaluationDeptProcess();
			evaluationDeptProcess.setId(id);
			evaluationDeptProcess.setBusinessId(id);
			EvaluationDeptBusinessPlan evaluationDeptBusinessPlan = null;
			EvaluationDeptBusinessAssessment evaluationDeptBusinessAssessment = null;
			if ("PLAN".equals(businessType)) {
				evaluationDeptBusinessPlan = evaluationDeptBusinessPlanService.getById(id);
				evaluationDeptProcess.setBusinessType("PLAN");
				evaluationDeptProcess.setDeptName(evaluationDeptBusinessPlan.getDeptName());
				evaluationDeptProcess.setAppraisalYear(evaluationDeptBusinessPlan.getAppraisalYear());
			} else if ("ASS".equals(businessType)) {
				evaluationDeptBusinessAssessment = evaluationDeptBusinessAssessmentService.getById(id);
				evaluationDeptProcess.setBusinessType("ASS");
				evaluationDeptProcess.setDeptName(evaluationDeptBusinessAssessment.getDeptName());
				evaluationDeptProcess.setAppraisalYear(evaluationDeptBusinessAssessment.getAppraisalYear());
			}

			if (null != evaluationDeptBusinessPlan||null!=evaluationDeptBusinessAssessment) {
				evaluationDeptProcess.setDeptId(String.valueOf(data.get("id")));
				evaluationDeptProcess.setDeptNo(String.valueOf(data.get("no")));
				evaluationDeptProcess.setDeptPersonalName(String.valueOf(data.get("name")));
				b = evaluationDeptProcessService.save(evaluationDeptProcess);
			}
		}
		if (b) {
			return R.ok().data(b);
		} else {
			return R.error("添加人员失败！");
		}
	}

}
